/**
 * generated by Xtext 2.27.0
 */
package org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.StlTextPackage;
import org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.interval;
import org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.intervalTime;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>interval</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.impl.intervalImpl#getTime1 <em>Time1</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.impl.intervalImpl#getTime2 <em>Time2</em>}</li>
 * </ul>
 *
 * @generated
 */
public class intervalImpl extends MinimalEObjectImpl.Container implements interval
{
  /**
   * The cached value of the '{@link #getTime1() <em>Time1</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTime1()
   * @generated
   * @ordered
   */
  protected intervalTime time1;

  /**
   * The cached value of the '{@link #getTime2() <em>Time2</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTime2()
   * @generated
   * @ordered
   */
  protected intervalTime time2;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected intervalImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return StlTextPackage.Literals.INTERVAL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public intervalTime getTime1()
  {
    return time1;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetTime1(intervalTime newTime1, NotificationChain msgs)
  {
    intervalTime oldTime1 = time1;
    time1 = newTime1;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StlTextPackage.INTERVAL__TIME1, oldTime1, newTime1);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setTime1(intervalTime newTime1)
  {
    if (newTime1 != time1)
    {
      NotificationChain msgs = null;
      if (time1 != null)
        msgs = ((InternalEObject)time1).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StlTextPackage.INTERVAL__TIME1, null, msgs);
      if (newTime1 != null)
        msgs = ((InternalEObject)newTime1).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StlTextPackage.INTERVAL__TIME1, null, msgs);
      msgs = basicSetTime1(newTime1, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StlTextPackage.INTERVAL__TIME1, newTime1, newTime1));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public intervalTime getTime2()
  {
    return time2;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetTime2(intervalTime newTime2, NotificationChain msgs)
  {
    intervalTime oldTime2 = time2;
    time2 = newTime2;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StlTextPackage.INTERVAL__TIME2, oldTime2, newTime2);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setTime2(intervalTime newTime2)
  {
    if (newTime2 != time2)
    {
      NotificationChain msgs = null;
      if (time2 != null)
        msgs = ((InternalEObject)time2).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StlTextPackage.INTERVAL__TIME2, null, msgs);
      if (newTime2 != null)
        msgs = ((InternalEObject)newTime2).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StlTextPackage.INTERVAL__TIME2, null, msgs);
      msgs = basicSetTime2(newTime2, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StlTextPackage.INTERVAL__TIME2, newTime2, newTime2));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case StlTextPackage.INTERVAL__TIME1:
        return basicSetTime1(null, msgs);
      case StlTextPackage.INTERVAL__TIME2:
        return basicSetTime2(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case StlTextPackage.INTERVAL__TIME1:
        return getTime1();
      case StlTextPackage.INTERVAL__TIME2:
        return getTime2();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case StlTextPackage.INTERVAL__TIME1:
        setTime1((intervalTime)newValue);
        return;
      case StlTextPackage.INTERVAL__TIME2:
        setTime2((intervalTime)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case StlTextPackage.INTERVAL__TIME1:
        setTime1((intervalTime)null);
        return;
      case StlTextPackage.INTERVAL__TIME2:
        setTime2((intervalTime)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case StlTextPackage.INTERVAL__TIME1:
        return time1 != null;
      case StlTextPackage.INTERVAL__TIME2:
        return time2 != null;
    }
    return super.eIsSet(featureID);
  }

} //intervalImpl
